/*
 * generated by Xtext 2.10.0
 */
package de.cau.cs.kieler.kgraph.text.ui.internal;

import com.google.common.collect.Maps;
import com.google.inject.Guice;
import com.google.inject.Injector;
import com.google.inject.Module;
import de.cau.cs.kieler.kgraph.text.GRandomRuntimeModule;
import de.cau.cs.kieler.kgraph.text.KGraphRuntimeModule;
import de.cau.cs.kieler.kgraph.text.ui.GRandomUiModule;
import de.cau.cs.kieler.kgraph.text.ui.KGraphUiModule;
import java.util.Collections;
import java.util.Map;
import org.apache.log4j.Logger;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.eclipse.xtext.ui.shared.SharedStateModule;
import org.eclipse.xtext.util.Modules2;
import org.osgi.framework.BundleContext;

/**
 * This class was generated. Customizations should only happen in a newly
 * introduced subclass. 
 */
public class TextActivator extends AbstractUIPlugin {

	public static final String DE_CAU_CS_KIELER_KGRAPH_TEXT_KGRAPH = "de.cau.cs.kieler.kgraph.text.KGraph";
	public static final String DE_CAU_CS_KIELER_KGRAPH_TEXT_GRANDOM = "de.cau.cs.kieler.kgraph.text.GRandom";
	
	private static final Logger logger = Logger.getLogger(TextActivator.class);
	
	private static TextActivator INSTANCE;
	
	private Map<String, Injector> injectors = Collections.synchronizedMap(Maps.<String, Injector> newHashMapWithExpectedSize(1));
	
	@Override
	public void start(BundleContext context) throws Exception {
		super.start(context);
		INSTANCE = this;
	}
	
	@Override
	public void stop(BundleContext context) throws Exception {
		injectors.clear();
		INSTANCE = null;
		super.stop(context);
	}
	
	public static TextActivator getInstance() {
		return INSTANCE;
	}
	
	public Injector getInjector(String language) {
		synchronized (injectors) {
			Injector injector = injectors.get(language);
			if (injector == null) {
				injectors.put(language, injector = createInjector(language));
			}
			return injector;
		}
	}
	
	protected Injector createInjector(String language) {
		try {
			Module runtimeModule = getRuntimeModule(language);
			Module sharedStateModule = getSharedStateModule();
			Module uiModule = getUiModule(language);
			Module mergedModule = Modules2.mixin(runtimeModule, sharedStateModule, uiModule);
			return Guice.createInjector(mergedModule);
		} catch (Exception e) {
			logger.error("Failed to create injector for " + language);
			logger.error(e.getMessage(), e);
			throw new RuntimeException("Failed to create injector for " + language, e);
		}
	}
	
	protected Module getRuntimeModule(String grammar) {
		if (DE_CAU_CS_KIELER_KGRAPH_TEXT_KGRAPH.equals(grammar)) {
			return new KGraphRuntimeModule();
		}
		if (DE_CAU_CS_KIELER_KGRAPH_TEXT_GRANDOM.equals(grammar)) {
			return new GRandomRuntimeModule();
		}
		throw new IllegalArgumentException(grammar);
	}
	
	protected Module getUiModule(String grammar) {
		if (DE_CAU_CS_KIELER_KGRAPH_TEXT_KGRAPH.equals(grammar)) {
			return new KGraphUiModule(this);
		}
		if (DE_CAU_CS_KIELER_KGRAPH_TEXT_GRANDOM.equals(grammar)) {
			return new GRandomUiModule(this);
		}
		throw new IllegalArgumentException(grammar);
	}
	
	protected Module getSharedStateModule() {
		return new SharedStateModule();
	}
	
}
