/*
 * KIELER - Kiel Integrated Environment for Layout Eclipse RichClient
 *
 * http://www.informatik.uni-kiel.de/rtsys/kieler/
 *
 * Copyright 2021 by
 * + Kiel University
 *   + Department of Computer Science
 *     + Real-Time and Embedded Systems Group
 *
 * generated by Xtext 2.9.2
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0.
 *
 * SPDX-License-Identifier: EPL-2.0
 */
package de.cau.cs.kieler.kgraph.text.validation

import de.cau.cs.kieler.kgraph.text.grandom.Configuration
import de.cau.cs.kieler.kgraph.text.grandom.Form
import de.cau.cs.kieler.kgraph.text.validation.AbstractGRandomValidator
import org.eclipse.xtext.validation.Check
import de.cau.cs.kieler.kgraph.text.grandom.GrandomPackage

/**
 * This class contains custom validation rules. 
 *
 * See https://www.eclipse.org/Xtext/documentation/303_runtime_concepts.html#validation
 */
class GRandomValidator extends AbstractGRandomValidator {
	
   	public static val errors = newArrayList(
   	        Pair.of([Configuration c | c.form != Form.TREES && c.MD], 
   	            Pair.of("maxDegree only defined on trees.", GrandomPackage.Literals.CONFIGURATION__MD)),
   	        Pair.of([Configuration c | c.form != Form.TREES && c.MW], 
                Pair.of("maxWidth only defined on trees.", GrandomPackage.Literals.CONFIGURATION__MW)), 
            Pair.of([Configuration c | c.form != Form.BIPARTITE && c.PF],
                Pair.of("Partition Fraction only defined on bipartite graphs.", 
                    GrandomPackage.Literals.CONFIGURATION__PF
                ))
   	        )
	
	@Check
	def optionsRestrictions(Configuration conf){
	    for (p : GRandomValidator.errors)
	        if (p.key.apply(conf))
	           error(p.value.key, p.value.value)
	}
}
